import io
import matplotlib.pyplot as plt
import numpy as np
from sklearn import preprocessing
from sklearn.cluster import KMeans
from tkinter import *
from flask import Flask,request,render_template
import webbrowser
import numpy as np
import statistics
import DTnum

# FUNCIO APROX QUE SERVEIX PER DISCRETITZAR ELS VALORS DE SUPERFICIE, PREU DE LES VIVENDES.
def aprox(num,interval):
	resta=num-(num//interval)*interval
	if resta < (interval/2.):
		aproximacio=num-resta
	else:
		aproximacio=num+interval-resta
	return aproximacio

#BASE DE DADES AMPLIADA QUE ES FA SERVIR PER REALITZAR L'ESTUDI DE VIVENDES, CONSTA DE MES DE 8000 VIVENDES.

fitxer=io.open('BBDD-Ampliada-Nova.csv','r')
llistastring=fitxer.readlines()
llistadellistestotal=[]
llistakmeans=[]
for i in llistastring:
		llistadellistestotal.append(i.split(';'))

for i in llistadellistestotal[1:]:

#TRACTAMENT DE CAMPS
		if len(i[30]) != 1:
			if i[1]=='Pis':
			   i[1]='1'
			else:
			   i[1]='0'
			   

			if i[8]=='Moblat':
			   i[8]='1'
			else:
			   i[8]='0'
			   
			i[9]=i[9].replace('.','')

			if i[16]=='No':
			   i[16]='0'
			else:
			   i[16]='1'


			i[17]=i[17].replace('No','0')

			i[18]=i[18].replace('No','0')

			i[19]=i[19].replace('No','0')

			if i[24]=='No':
			   i[24]='0'
			else:
			   i[24]='1'

			   
			if i[25]=='No':
			   i[25]='0'
			else:
			   i[25]='1'
			llistakmeans.append([i[1],i[4],i[5],aprox(int(i[7]),10),i[8],aprox(int(i[9]),200000),aprox(int(i[11]),50),i[13],i[15],i[16],i[17],i[18],i[19],i[20],i[21],i[24],i[25],i[29],i[30]])

#UNA VEGADA TRACTAR CERTS CAMPS DE LA BASE DE DADES JA ES PODEN CONVERTIR EN FLOAT PREVI PAS A INT DE ALGUN CAMP STRING. AIXI ES PODRAN TRACTAR EN DIFERENTS METODES
#I PROCEDIMENTS.
for i in range(len(llistakmeans)):
	for j in range(len(llistakmeans[0])):
		if j!=1 and j!=2 and j!=len(llistakmeans[0])-1 and j!=len(llistakmeans[0])-2:
			llistakmeans[i][j]=float(llistakmeans[i][j])
llistakmeans=llistakmeans[1:len(llistakmeans)]

#ES CREA UNA LLISTA AMB TOTS ELS DISTRICTES

districtes=[]
for i in llistakmeans:
		if i[1] not in districtes:
			districtes.append(i[1])




###########################################################################################################################################
#A PARTIR DE ARA TREBALLAREM AMB llistakmeans QUE ES LA BASE DEL K-MEANS TAMBÉ UTILITZADA A LA PART DE CLIENT DE FLASK
###########################################################################################################################################
# district ES UN DICCIONARI ON EMMAGATZAMEM LES MITJANES DELS DIFERENTS CAMPS DEL DISTRICTE.
# dictcentral ES UN DICCIONARI QUE EMMAGATZEMA INFORMACIO SOBRE DADES ESTADISTIQUES DE CADA CENTROID.
# llistacentral ES UNA LLISTA QUE UTILITZEM PER REALITZAR ELS CALCULS K-MEANS A PARTIR DE LA LLISTA llistakmeans.
# AQUESTES VARIABLES LES DEFINIM AQUI ABANS DE ENTRAR AL BUCLE QUE ITERARA AL VOLTANT DELS DIFERENTS DISTRICTES

dictcentral={}
district={}
postanalisi=[]


#CODI ESTADISTIQUES EN UN BUCLE QUE ITERA EN TOTS ELS DISTRICTES DE FORMA INDIVIDUAL.

for districte in districtes:
			any=[]
			preu=[]
			superficie=[]
			habitacions=[]
			banys=[]
			garatge=[]
			tipus=[]
			mobles=[]
			aire=[]
			terrassa=[]
			balco=[]
			sauna=[]
			gimnas=[]
			ascensor=[]
			cee=[]
			subtipus=[]
			estat=[]
			piscina=[]
			calefaccio=[]
			camps=['any','preu milers','superficie','habitacions','banys','garatge','% moblat','% aire','terrassa','% balco','% sauna','% gimnas','% ascensor','% cee']
			valors=[]
        
			for i in llistadellistestotal[1:]:
				if districte in i and len(i[7])!=0:
					
					subtipus.append(i[2])
					estat.append(i[3])
					piscina.append(i[22])
					calefaccio.append(i[23])
					any.append(int(i[7]))
					preu.append(int(i[9].replace('.','')))
					superficie.append(int(i[11]))
					habitacions.append(int(i[13]))
					banys.append(int(i[15]))
					garatge.append(int(i[19].replace('No','0')))
					terrassa.append(int(i[17].replace('No','0')))
					balco.append(int(i[18].replace('No','0')))
					tipus.append(int(i[1]))
					mobles.append(int(i[8]))
					aire.append(int(i[16]))
					sauna.append(int(i[20]))
					gimnas.append(int(i[21]))
					ascensor.append(int(i[24]))
					cee.append(int(i[25]))

             
			if len(any)!=0 and len(preu)!=0 and len(superficie)!=0 and len(habitacions)!=0:
				valors.append(statistics.mean(any))
				valors.append(statistics.mean(preu)/1000)
				valors.append(statistics.mean(superficie))
				valors.append(statistics.mean(habitacions))
				valors.append(statistics.mean(banys))
				valors.append(statistics.mean(garatge))
				valors.append(100*statistics.mean(mobles))
				valors.append(100*statistics.mean(aire))
				valors.append(statistics.mean(terrassa))
				valors.append(100*statistics.mean(balco))
				valors.append(100*statistics.mean(sauna))
				valors.append(100*statistics.mean(gimnas))
				valors.append(100*statistics.mean(ascensor))
				valors.append(100*statistics.mean(cee))
			district[districte]=valors

#####################################################################################################################################################    
############################CODI DEL KMEANS#########################################################################################################
####################################################################################################################################################

			llistacentral=[]
			for i in llistakmeans:
				if districte in i:
					llistacentral.append([i[0],i[3],i[4],i[5],i[6],i[7],i[8],i[9],i[10],i[11],i[12],i[13],i[14],i[15],i[16],i[len(i)-2],i[len(i)-1]])
			if len(llistacentral)<4:
				pass
			else:
				matriu=np.array([i[0:len(i)-2] for i in llistacentral])
				normalizedarray=preprocessing.scale(matriu)
				idx = KMeans(init='k-means++', n_clusters=3, n_init=10)
				idx.fit(normalizedarray,y=None)
				centroids=idx.cluster_centers_
				centroides=idx.fit_predict(normalizedarray,y=None)
				centroidistrictes=[]
				for j in range(4):
					
					try:
							easy=0
							medium=0
							difficult=0
							notselled=0
							for i in range(len(centroides)):
								
								if centroides[i]==j:
									if llistacentral[i][len(llistacentral[0])-1]=='Fàcil\n':
										easy=easy+1
										postanalisi.append([districte,j,'Fàcil',llistacentral[i]])
									elif llistacentral[i][len(llistacentral[0])-1]=='Mitjà\n':
										medium=medium+1
										postanalisi.append([districte,j,'Mitjà',llistacentral[i]])
									elif llistacentral[i][len(llistacentral[0])-1]=='Difícil\n':
										difficult=difficult+1
										postanalisi.append([districte,j,'Difícil',llistacentral[i]])
									else:
										notselled=notselled+1
										postanalisi.append([districte,j,'No venut',llistacentral[i]])
							centroidistrictes.append(str(round(easy*100/(easy+medium+difficult+notselled),1))+str(' (')+str(easy)+str(') '))
							centroidistrictes.append(str(round(medium*100/(easy+medium+difficult+notselled),1))+str(' (')+str(medium)+str(') '))
							centroidistrictes.append(str(round(difficult*100/(easy+medium+difficult+notselled),1))+str(' (')+str(difficult)+str(') '))
							centroidistrictes.append(str(round(notselled*100/(easy+medium+difficult+notselled),1))+str(' (')+str(notselled)+str(') '))
					except:
							pass
			dictcentral[districte]=centroidistrictes

##################################################################################################################################
##################################################  ARBRES DE DECISIO ############################################################
##################################################################################################################################

llistadecisiontree=[]
for i in llistakmeans:
	if i[1]=='Les Corts' and i[-1]!='No venut\n':
		llistadecisiontree.append([i[0],i[3],i[4],i[5],i[6],i[7],i[8],i[9],i[10],i[11],i[12],i[13],i[14],i[15],i[16],i[len(i)-2],i[len(i)-1]])
for i in llistadecisiontree:
		i[-1]=i[-1].replace('\n','')
finallist=[]
for i in range(len(llistadecisiontree)):
		dict={}
		dict['Tipus']=float(llistadecisiontree[i][0])
		dict['Any']=float(llistadecisiontree[i][1])
		dict['Mobles']=float(llistadecisiontree[i][2])
		dict['Preu']=float(llistadecisiontree[i][3])
		dict['Superficie']=float(llistadecisiontree[i][4])
		dict['Habitacions']=float(llistadecisiontree[i][5])
		dict['Banys']=float(llistadecisiontree[i][6])
		dict['Aire']=float(llistadecisiontree[i][7])
		dict['Terrassa']=float(llistadecisiontree[i][8])
		dict['Balco']=float(llistadecisiontree[i][9])
		dict['Garatge']=float(llistadecisiontree[i][10])
		dict['Sauna']=float(llistadecisiontree[i][11])
		dict['Gimnas']=float(llistadecisiontree[i][12])
		dict['Ascensor']=float(llistadecisiontree[i][13])
		dict['cee']=float(llistadecisiontree[i][14])
		dict['class']=llistadecisiontree[i][16]
		finallist.append(dict)


#################################################################################################################################################3
# A DTNUM.PY es troba la funcio GOODNESS IMPLEMENTADA

# GENEREM ARBRE DE DECISIO DE TOTA BARCELONA I CALCULEM EXACTITUD 
 
dectree=DTnum.generateDT(finallist,max_depth=10,min_accuracy=0.8)



##########################################################################################################################################################
##########################################################PREPARACIO DE LES NOSTRES DADES PEL FLASK#######################################################
##########################################################################################################################################################
for i in district.values():
    for j in range(len(i)):
        i[j]=round(i[j],1)
diccionariskmeans={}
#POSTANALISI 
def analisi(postanalisi,distrito,dificultad):
	counter0=[]
	counter1=[]
	counter2=[]
	for i in postanalisi:
		if i[0]==distrito and i[2]==dificultad:
			if i[1]==1:
				counter0.append(i)
			elif i[1]==0:
				counter1.append(i)
			else:
				counter2.append(i)
	####j representa cadascun dels elements de qui volem fer la mitjana
	estats=[]
	if len(counter0)!=0:
		for j in range(len(counter0[0][3])-2):
			caracteristica=[]
			for i in range(len(counter0)):
				caracteristica.append(counter0[i][3][j])
			if len(caracteristica)!=0:
				estats.append((0,round(statistics.mean(caracteristica),1)))
		estats.append(len(counter0))
	if len(counter1)!=0:
		for j in range(len(counter1[0][3])-2):
			caracteristica=[]
			for i in range(len(counter1)):
				caracteristica.append(counter1[i][3][j])
			if len(caracteristica)!=0:
				estats.append((1,round(statistics.mean(caracteristica),1)))
		estats.append(len(counter1))
	if len(counter2)!=0:
		for j in range(len(counter2[0][3])-2):
			caracteristica=[]
			for i in range(len(counter2)):
				caracteristica.append(counter2[i][3][j])
			if len(caracteristica)!=0:
				estats.append((2,round(statistics.mean(caracteristica),1)))
		estats.append(len(counter2))
	return estats
for i in districtes:
	for j in ['Fàcil','Mitjà','Difícil','No venut']:
		diccionariskmeans[(i,j)]=analisi(postanalisi,i,j)

###################################################################################################################################################################
###########################INICIALITZACIO DEL FLASK UNA VEGADA QUE EL PYTHON HA FET ELS SEUS CALCULS###############################################################
###################################################################################################################################################################

app=Flask(__name__)


# ES DEFINEIX LA FUNCIO full_name PER PODER CRIDAR-LA DES DE LA PLANTILLA seleccio.html QUE DEFINEIX LA INTERACCIÓ DEL CLIENT AMB EL PRESENT PROJECTE

@app.context_processor
def some_processor():
    def full_name(districte):
        cucu=''
        for i in llistakmeans:
            if districte in i and 'No venut\n' in i :
               cucu=cucu+str(i[0:-2])
        return cucu
    return {'full_name': full_name}



# ES DEFINEIX EL DECORADOR QUE ENS MOSTRA ELS ENLLAÇOS DELS DIFERENTS DISTRICTES I QUE SERVIRA PER ACCEDIR A LES ESTADISTIQUES I CENTROIDS DE CADA DISTRICTE. FORMA PART
# DE LA PART DE L'EMPRESA.

@app.route('/')
def index():
    return render_template("llistat.html",districtes=districtes)

# AQUEST DECORADOR ENLLAÇA LA PAGINA INICIAL QUE MOSTRA EL FLASK AMB LES DADES DE CADA DISTRICTE.
# FORMA PART DE L'EMPRESA

@app.route('/<districte>')
def barriada(districte):
    return render_template("barry.html",districte=districte,dictcentral=dictcentral,district=district,camps=camps,diccionariskmeans=diccionariskmeans)

# AQUEST DECORADOR ENLLAÇA AMB LA PÀGINA DE FILTRES I RECOMANACIONS PER AL CLIENT.

@app.route('/recomana')
def recomana():
    return render_template("seleccio.html",districtes=districtes,dictcentral=dictcentral)



# CRIDA A LA CARREGA DE FLASK I LLENCAMENT AUTOMATIC DE LA WEB.
if __name__=="__main__":
     location="http://127.0.0.1:5000"
     webbrowser.open_new(location)
     app.run(debug=True)
     